unit schImpresionesClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Impresiones = '{EAA2FFEA-7F70-4B38-A9DD-302CB54EDF1C}';

  { Data table names }
  nme_Impresiones = 'Impresiones';

  { Impresiones fields }
  fld_ImpresionesID = 'ID';
  fld_ImpresionesTABLA = 'TABLA';
  fld_ImpresionesID_TABLA = 'ID_TABLA';
  fld_ImpresionesNUM_COPIAS = 'NUM_COPIAS';

  { Impresiones field indexes }
  idx_ImpresionesID = 0;
  idx_ImpresionesTABLA = 1;
  idx_ImpresionesID_TABLA = 2;
  idx_ImpresionesNUM_COPIAS = 3;

type
  { IImpresiones }
  IImpresiones = interface(IDAStronglyTypedDataTable)
  ['{4CADBD7F-0B03-4453-BD72-CAB44E9F590D}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetTABLAValue: String;
    procedure SetTABLAValue(const aValue: String);
    function GetID_TABLAValue: Integer;
    procedure SetID_TABLAValue(const aValue: Integer);
    function GetNUM_COPIASValue: Integer;
    procedure SetNUM_COPIASValue(const aValue: Integer);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property TABLA: String read GetTABLAValue write SetTABLAValue;
    property ID_TABLA: Integer read GetID_TABLAValue write SetID_TABLAValue;
    property NUM_COPIAS: Integer read GetNUM_COPIASValue write SetNUM_COPIASValue;
  end;

  { TImpresionesDataTableRules }
  TImpresionesDataTableRules = class(TDADataTableRules, IImpresiones)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetTABLAValue: String; virtual;
    procedure SetTABLAValue(const aValue: String); virtual;
    function GetID_TABLAValue: Integer; virtual;
    procedure SetID_TABLAValue(const aValue: Integer); virtual;
    function GetNUM_COPIASValue: Integer; virtual;
    procedure SetNUM_COPIASValue(const aValue: Integer); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property TABLA: String read GetTABLAValue write SetTABLAValue;
    property ID_TABLA: Integer read GetID_TABLAValue write SetID_TABLAValue;
    property NUM_COPIAS: Integer read GetNUM_COPIASValue write SetNUM_COPIASValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TImpresionesDataTableRules }
constructor TImpresionesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TImpresionesDataTableRules.Destroy;
begin
  inherited;
end;

function TImpresionesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_ImpresionesID].AsInteger;
end;

procedure TImpresionesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ImpresionesID].AsInteger := aValue;
end;

function TImpresionesDataTableRules.GetTABLAValue: String;
begin
  result := DataTable.Fields[idx_ImpresionesTABLA].AsString;
end;

procedure TImpresionesDataTableRules.SetTABLAValue(const aValue: String);
begin
  DataTable.Fields[idx_ImpresionesTABLA].AsString := aValue;
end;

function TImpresionesDataTableRules.GetID_TABLAValue: Integer;
begin
  result := DataTable.Fields[idx_ImpresionesID_TABLA].AsInteger;
end;

procedure TImpresionesDataTableRules.SetID_TABLAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ImpresionesID_TABLA].AsInteger := aValue;
end;

function TImpresionesDataTableRules.GetNUM_COPIASValue: Integer;
begin
  result := DataTable.Fields[idx_ImpresionesNUM_COPIAS].AsInteger;
end;

procedure TImpresionesDataTableRules.SetNUM_COPIASValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ImpresionesNUM_COPIAS].AsInteger := aValue;
end;


initialization
  RegisterDataTableRules(RID_Impresiones, TImpresionesDataTableRules);

end.
